--loop
DECLARE
i NUMBER;
j NUMBER;
BEGIN
i:=1;
SELECT COUNT(matricula) INTO j FROM aluno;
LOOP
dbms_output.put_line('Valor de i: '||i);
i:=i+1;
EXIT WHEN i=j;
END LOOP;
dbms_output.put_line('O nmero de alunos matriculados : '||j);
END;
/

--while
DECLARE
i NUMBER;
j NUMBER;
BEGIN
i:=1;
SELECT COUNT(matricula) INTO j FROM aluno;
WHILE i <> j LOOP
dbms_output.put_line('Valor de i: '||i);
i:=i+1;
END LOOP;
dbms_output.put_line('O nmero de alunos matriculados : '||j);
END;
/

--for/if
DECLARE
i NUMBER;
j NUMBER;
BEGIN
i:=1;
SELECT COUNT(matricula) INTO j FROM aluno;
FOR k IN i..j LOOP
dbms_output.put_line('Valor de k: '||k);
END LOOP;
dbms_output.put_line('O nmero de alunos matriculados : '||j);
END;
/

--goto
DECLARE
i NUMBER := 1;
BEGIN
IF i = 1 THEN
GOTO tagQualquer;
ELSE
i := 1;
END IF;
<<tagQualquer>>
DBMS_OUTPUT.PUT_LINE('i = 1');
NULL;
END;
/

--tratamento de erro
CREATE OR REPLACE FUNCTION nTurmas(codCurso NUMBER) RETURN NUMBER IS
qtd NUMBER;
BEGIN
SELECT COUNT(cod_c) INTO qtd FROM turma
WHERE cod_c = codCurso;
RETURN qtd;

EXCEPTION
WHEN NO_DATA_FOUND THEN
RETURN NULL;

END;
/

--cursor/begin
CREATE OR REPLACE FUNCTION turmas(cpf professOR.cpf_p%TYPE) RETURN NUMBER IS
CURSOR t IS SELECT turma.cod_c, turma.n_fila, turma.nivel
FROM turma WHERE turma.cpf_p = cpf;
aux t%ROWTYPE;
retORno NUMBER;
BEGIN
OPEN t;
LOOP
FETCH t INTO aux;
EXIT WHEN t%NOTFOUND;
dbms_output.put_line('Curso: '||aux.cod_c||' '||'Numero: '
||aux.n_fila||' '||'Nivel '||aux.nivel);
END LOOP;
CLOSE t;
RETURN retORno;
END;
/

--tipo
CREATE OR REPLACE TRIGGER niveis BEFORE INSERT OR UPDATE ON inscricao FOR EACH ROW
DECLARE 
niv turma.nivel%TYPE;
qtde NUMBER := 0;
BEGIN
SELECT nivel INTO niv
FROM turma t
WHERE t.cod_c = :NEW.cod_c
AND t.n_fila = :NEW.n_fila;
SELECT COUNT(DISTINCT nivel) INTO qtde
FROM turma t, inscricao i
WHERE i.cod_c = t.cod_c
AND i.n_fila = t.n_fila
AND t.cod_c = :NEW.cod_c
AND i.matricula = :NEW.matricula
AND (SUBSTR(i.semestre, 1, 4) < SUBSTR(:NEW.semestre, 1,4)
OR (SUBSTR(i.semestre, 1, 4) = SUBSTR(:NEW.semestre, 1,4)
AND SUBSTR(i.semestre, 6, 1) < SUBSTR(:NEW.semestre, 6,1)));
IF(niv = 'I' and qtde < 1) THEN raise_application_error(-20101, 'Va para o basico');
ELSIF(niv = 'A' and qtde < 2) THEN raise_application_error(-20101,'Va para o intermediario');
ELSE dbms_output.put_line('Aluno inscrito com sucesso');
END if;
END;
/

--bloco anonimo
DECLARE
i NUMBER;
j NUMBER;
BEGIN
i:=1;
SELECT COUNT(matricula) INTO j FROM aluno;
LOOP
dbms_output.put_line('ValOR de i: '||i);
i:=i+1;
EXIT WHEN i=j;
END LOOP;
dbms_output.put_line('O nmero de alunos matriculados : '||j);
END;
/

--case
DECLARE
id NUMBER := &numero;
descricao VARCHAR2(20);
BEGIN
descricao :=
CASE
WHEN id = 1 THEN 'Ingles'
WHEN id = 2 THEN 'Espanhol'
WHEN id = 3 THEN 'Frances'
WHEN id = 4 THEN 'Alemao'
WHEN id = 5 THEN 'Italiano'
WHEN id = 6 THEN 'Mandarim'
ELSE 'Desconhecido'
END;
DBMS_OUTPUT.PUT_LINE ('Idioma:  '|| id ||
'  ' || descricao);
END;
/


--procedure
CREATE OR REPLACE PROCEDURE extremos IS
CURSOR alunos IS (SELECT nome FROM aluno a, inscricao i
WHERE a.matricula = i.matricula
and (i.conversacao = 10
OR i.leitura = 10
OR i.escrita = 10)) 
intersect 
(SELECT nome FROM aluno a, inscricao i
WHERE a.matricula = i.matricula
and (i.conversacao = 0
OR i.leitura = 0
OR i.escrita = 0));
BEGIN
fOR aux in alunos LOOP
dbms_output.put_line(aux.nome);
END LOOP;
END;
/

--function
CREATE OR REPLACE FUNCTION turmas(cpf professor.cpf_p%TYPE) RETURN NUMBER IS
CURSOR t IS SELECT turma.cod_c, turma.n_fila, turma.nivel
FROM turma WHERE turma.cpf_p = cpf;
aux t%ROWTYPE;
retorno NUMBER;
BEGIN
OPEN t;
LOOP
FETCH t INTO aux;
EXIT WHEN t%NOTFOUND;
dbms_output.put_line('Curso: '||aux.cod_c||' '||'Numero: '
||aux.n_fila||' '||'Nivel '||aux.nivel);
END LOOP;
CLOSE t;
RETURN retorno;
END;
/

--trigger de comando
CREATE OR REPLACE TRIGGER atualizacao
AFTER UPDATE OF idioma ON curso
BEGIN
DBMS_OUTPUT.PUT_LINE('Atualizao feita com sucesso!');
END;
/

--trigger de linha
CREATE OR REPLACE TRIGGER resp BEFORE INSERT OR UPDATE ON aluno FOR EACH ROW
DECLARE
qtde_alunos NUMBER;
BEGIN
SELECT COUNT(cpf_r) INTO qtde_alunos
FROM aluno
WHERE cpf_r = :NEW.cpf_r;
CASE
WHEN qtde_alunos in (1,0) then dbms_output.put_line('Aluno cadastrado com sucesso');
else raise_application_error(-20101,'Numero maximo de alunos para esse 
responsavel atingido');
END CASE;
END;
/

--package (especificao)
CREATE OR REPLACE PACKAGE update_idioma IS
PROCEDURE up(cod NUMBER);
END update_idioma;
/

--package (corpo)
CREATE OR REPLACE PACKAGE BODY update_idioma IS
procedure up(cod NUMBER) IS
BEGIN
update curso
set idioma='japones'
WHERE cod_c = cod;
END up;
END update_idioma;
/

--rowtype
CREATE OR REPLACE FUNCTION turmas(cpf professor.cpf_p%TYPE) RETURN NUMBER IS
CURSOR t IS SELECT turma.cod_c, turma.n_fila, turma.nivel
FROM turma WHERE turma.cpf_p = cpf;
aux t%ROWTYPE;
retorno NUMBER;
BEGIN
OPEN t;
LOOP
FETCH t INTO aux;
EXIT WHEN t%NOTFOUND;
dbms_output.put_line('Curso: '||aux.cod_c||' '||'Numero: '
||aux.n_fila||' '||'Nivel '||aux.nivel);
END LOOP;
CLOSE t;
RETURN retorno;
END;
/